﻿Type=Class
Version=4.01
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'HttpUtils2 version 2.01
'Class module
Sub Class_Globals
	Public JobName As String
	Public Success As Boolean
	Public Username, Password As String
	Public ErrorMessage As String
	Private target As Object
	Private taskId As String
	Private req As HttpRequest
	Public Tag As Object
	Type MultipartFileData (Dir As String, FileName As String, KeyName As String, ContentType As String)
#If UI
	Private fx As JFX
#end if
End Sub

'Initializes the Job.
'Name - The job's name. Note that the name doesn't need to be unique.
'TargetModule - The activity or service that will handle the JobDone event.
Public Sub Initialize (Name As String, TargetModule As Object)
	HttpUtils2ServiceBlackberry.Initialize
	JobName = Name
	target = TargetModule
End Sub
'
'Sends a POST request with the given string as the post data
Public Sub PostBytes(Link As String, Data() As Byte)
	req.InitializePost2(Link, Data)
	CallSubDelayed2(HttpUtils2ServiceBlackberry, "SubmitJob", Me)
End Sub

'Abgeänderte PostMultipart-Sub zum Versenden der Blackberry-Push Nachricht im XML-Format'
'NameValues - A map with the keys and values. Pass Null if not needed.
public Sub PostMultipartXML(Link As String)
	
	Dim Absender As String = "Blackberry"
	Dim Filename As String = "test.txt"
	Dim Daten As String = "test"
	Dim Zeitstempel As Long = 1452172482568
	Dim Groesse As Int = 1234
	
	Dim b() As Byte
	Dim eol As String = Chr(13) & Chr(10)
	
		Dim s As String = _
$"--PMasdfglkjhqwert
Content-Type: application/xml; charset=UTF-8
<?xml version="1.0"?>
<!DOCTYPE pap PUBLIC "-//WAPFORUM//DTD PAP 2.1//EN" "http://www.openmobilealliance.org/tech/DTD/pap_2.1.dtd">
<pap>
  <push-message push-id="999999999"  source-reference="XXXX-546353vcgsfsre46424M988518o8645vdgdfd64"  deliver-before-timestamp="2020-12-31T23:59:59Z">    <address address-value="3E4D4545"/>
    <quality-of-service delivery-method="confirmed"/>
  </push-message>
</pap>
--PMasdfglkjhqwert

{"Absender":"${Absender}", "Filename":"${Filename}", "Daten":"${Daten}", "Zeitstempel":"${Zeitstempel}", "Groesse":"${Groesse}"}
--PMasdfglkjhqwert–-"$
		
	b = s.Replace(CRLF, eol).GetBytes("UTF8")
	PostBytes(Link, b)
	req.SetContentType("multipart/related;boundary=PMasdfglkjhqwert;type=application/xml")	
	req.SetHeader("Authorization", "Basic GHHFDFDFDBBdh6645grjRNOTg4NTE4bzhpMDQyMDVsN656565QWERRFFRZOVnJONg==")
End Sub

'Called by the service to get the request
Public Sub GetRequest As HttpRequest
	Return req
End Sub

'Called by the service when job completes
Public Sub Complete (id As Int)
	taskId = id
	CallSubDelayed2(target, "JobDone", Me)
End Sub

'Should be called to free resources held by this job.
Public Sub Release
	File.Delete(HttpUtils2ServiceBlackberry.TempFolder, taskId)
End Sub

'Returns the response as a string encoded with UTF8.
Public Sub GetString As String
	Return GetString2("UTF8")
End Sub
'
'Returns the response as a string.
Public Sub GetString2(Encoding As String) As String
	Dim tr As TextReader
	tr.Initialize2(File.OpenInput(HttpUtils2ServiceBlackberry.TempFolder, taskId), Encoding)
	Dim res As String
	res = tr.ReadAll
	tr.Close
	Return res
End Sub
